let addn m n = m + n

let add_one = addn 1

let add_two = addn 2

let rec f m = 
  if m=0 
  then [] 
  else (addn m)::(f (m-1))

let rec map f lst =
  match lst with
    []     -> []
  | hd::tl -> (f hd)::(map f tl)

(* just a function pointer *)
let incr lst = map (fun x -> x+1) lst
let incr     = map (fun x -> x+1)

(* a closure *)
let mul i lst = map (fun x -> x*i) lst
let mul i     = map (fun x -> x*i)

let rec fold_left f acc lst =
  match lst with
    []     -> acc
  | hd::tl -> fold_left f (f acc hd) tl

(* just function pointers *)
let f1 = fold_left (fun x y -> x+y) 0
let f2 = fold_left (fun x y -> x && y>0) true

(* a closure *)
let f3 lst (lo : int) hi = 
 fold_left 
 (fun x y -> if y>lo && y<hi then x+1 else x)
 0 lst

let f4 g h = (fun x -> g (h x))

type 'a option = None | Some of 'a (*predefined*)

let f5 g h x = 
  match g x with
    None   -> h x
  | Some y -> y

type set = { add    : int -> set; 
             member : int -> bool }
let empty_set = 
  let exists lst j = (*could use fold_left!*)
     let rec iter rest =
        match rest with 
          []     -> false 
        | hd::tl -> j=hd || iter tl in
     iter lst in
  let rec make_set lst = 
      { add    = (fun i -> make_set(i::lst));
        member = exists lst } in
  make_set []

let rec fact1 x = 
  if x==0 then 1 else x * (fact1(x-1))

let fact2 x = 
  let rec f acc x =
	  if x==0 then acc else f (acc*x) (x-1)
  in
  f 1 x

let rec sum1 lst = 
  match lst with 
    []     -> 0
  | hd::tl -> hd + (sum1 tl)
let sum2 lst = 
  let rec f acc lst = 
     match lst with 
      []     -> acc
    | hd::tl -> f (acc+hd) tl
  in
  f 0 lst

type tree = Leaf of int | Node of tree * tree
let sum tr = 
  let rec f acc tr = 
     match tr with 
      Leaf i -> acc+i
    | Node(left,right) -> f (f acc left) right
  in
  f 0 tr
